local ck = chaosKart

----------------
-- EVENT LIST --
----------------

ck.events[1] = {
	name = "Explode 1st",
	id = "Explode1st",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "First Place has exploded!",
	length = 70,
	runfunc = function()
		local p = ck.getFirstPlace()
		P_StartQuake(30*FRACUNIT, TICRATE/2)
		K_SpawnMineExplosion(p.mo, p.mo.color)
		p.kartstuff[k_spinouttimer] = TICRATE
		p.kartstuff[k_sneakertimer] = 0
		P_InstaThrust(p.mo, p.mo.angle, 0)
		P_SetObjectMomZ(p.mo, 30*FRACUNIT)
		S_StartSound(p.mo, sfx_bkpoof)
	end,
}

ck.events[2] = {
	name = "Explosions",
	id = "Explosions",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = true,
	desc = "Explosions! Explosions!",
	length = 70,
	runfunc = function()
		P_StartQuake(30*FRACUNIT, TICRATE/2)
		for p in players.iterate do
			if p.mo and p.mo.valid then
				K_SpawnMineExplosion(p.mo, p.mo.color)
				p.kartstuff[k_spinouttimer] = TICRATE
				p.kartstuff[k_sneakertimer] = 0
				P_InstaThrust(p.mo, p.mo.angle, 0)
				P_SetObjectMomZ(p.mo, 30*FRACUNIT)
				S_StartSound(p.mo, sfx_bkpoof)
			end
		end
	end,
}

ck.events[3] = {
	name = "Invincibility",
	id = "InvincLast",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Last place has gained invincibility!",
	length = 70,
	runfunc = function()
		local p = ck.getLastPlace()
		p.kartstuff[k_invincibilitytimer] = 15*TICRATE
	end,
}

ck.events[4] = {
	name = "Growth",
	id = "GrowLast",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Last place has grown!",
	length = 70,
	runfunc = function()
		local p = ck.getLastPlace()
		p.mo.destscale = 3*(mapobjectscale/2)
		p.kartstuff[k_growshrinktimer] = 15*TICRATE
	end,
}

ck.events[5] = {
	name = "No Drift?",
	id = "Driftless",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Drifting functions broken...",
	length = 70,
	varlength = 25*TICRATE,
	runfunc = function()
		S_StartSound(nil, sfx_s3k83)
	end,
	playerthink = function(p)
		p.kartstuff[k_drift] = 0
	end
}

ck.events[6] = {
	name = "SPB",
	id = "SPBLast",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Last place got an SPB!",
	length = 70,
	canrun = function()
		local p = ck.getLastPlace()
		return p and p.valid and p.kartstuff[k_itemamount] <= 0
	end,
	runfunc = function()
		local p = ck.getLastPlace()
		p.kartstuff[k_itemtype] = 10
		p.kartstuff[k_itemamount] = 1
	end,
}

ck.events[7] = {
	name = "Thunder",
	id = "Shrink1st",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "First Place has shrunk!",
	length = 70,
	runfunc = function()
		local p = ck.getFirstPlace()
		p.mo.destscale = 3*(mapobjectscale/4)
		p.kartstuff[k_growshrinktimer] = -15*TICRATE

		P_DamageMobj(p.mo)
		p.kartstuff[k_sneakertimer] = 0

		local bolt = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
		bolt.target = p.mo
		bolt.state = S_LZIO11
		bolt.color = SKINCOLOR_GOLD

		bolt = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
		bolt.target = p.mo
		bolt.state = S_LZIO21
		bolt.color = SKINCOLOR_YELLOW
	end,
}

ck.events[8] = {
	name = "Thunderstorm",
	id = "ShrinkAll",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "Everyone has been shrunk!",
	length = 70,
	runfunc = function()
		for p in players.iterate do
			if p.mo and p.mo.valid then
				p.mo.destscale = 3*(mapobjectscale/4)
				p.kartstuff[k_growshrinktimer] = (-15 - p.kartstuff[k_position])*TICRATE

				P_DamageMobj(p.mo)
				p.kartstuff[k_sneakertimer] = 0

				local bolt = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
				bolt.target = p.mo
				bolt.state = S_LZIO11
				bolt.color = SKINCOLOR_GOLD

				bolt = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
				bolt.target = p.mo
				bolt.state = S_LZIO21
				bolt.color = SKINCOLOR_YELLOW
			end
		end
	end,
}

ck.events[9] = {
	name = "Flipped!",
	id = "FlipRand",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "A random player has been turned around.",
	length = 70,
	runfunc = function()
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		if pl.mo then pl.mo.angle = $ + ANGLE_180 end
	end,
}

ck.events[10] = {
	name = "Dizzying!",
	id = "RandAngle",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "Your angle has been randomized!",
	length = 70,
	runfunc = function()
		for p in players.iterate
			if p and p.mo then p.mo.angle = P_RandomRange(0, 359)*ANG1 end
		end
	end,
}

ck.events[11] = {
	name = "Who Spun out?",
	id = "RandDmg",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "A random player has been spun out!",
	length = 70,
	runfunc = function()
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local angle = P_RandomRange(0, 360)*FRACUNIT
		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]

		if pl.mo then
			P_DamageMobj(pl.mo)
			pl.kartstuff[k_sneakertimer] = 0
			P_InstaThrust(pl.mo, angle, P_RandomRange(4, 10)*FRACUNIT)
			P_SetObjectMomZ(pl.mo, P_RandomRange(-5, 20)*FRACUNIT)
		end
	end,
}

ck.events[12] = {
	name = "Nyooom",
	id = "Nyoom",
	namecol = SKINCOLOR_ORANGE,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Everyone got a speed boost!",
	length = 70,
	runfunc = function()
		for p in players.iterate do
			if p.mo and p.mo.valid then
				K_DoSneaker(p)
				p.kartstuff[k_sneakertimer] = 5*TICRATE
			end
		end
	end,
}

ck.events[13] = {
	name = "Hot Wheels",
	id = "HotWheels",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = true,
	desc = "Everyone got a lengthy speed boost!",
	length = 70,
	runfunc = function(time)
		for p in players.iterate do
			if p.mo and p.mo.valid then
				K_DoSneaker(p)
				p.kartstuff[k_sneakertimer] = time or 15*TICRATE
			end
		end
	end,
}

ck.events[14] = {
	name = "Catchup",
	id = "LastBoost",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "Last place got a catchup boost.",
	length = 70,
	runfunc = function(time)
		local p = ck.getLastPlace()
		K_DoSneaker(p)
		p.kartstuff[k_sneakertimer] = 15*TICRATE
	end,
}

ck.events[15] = {
	name = "Orbi Mayhem!",
	id = "OrbiMayhem",
	namecol = SKINCOLOR_ORANGE,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "A random able player got 7 orbinauts.",
	length = 70,
	runfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo and p.kartstuff[k_itemamount] <= 0 then table.insert(possibleplayers, p) end
		end

		if #possibleplayers then
			local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
			pl.kartstuff[k_itemtype] = KITEM_ORBINAUT
			pl.kartstuff[k_itemamount] = 7
		end
	end,
}

ck.events[16] = {
	name = "Random Stats!",
	id = "RandStats",
	namecol = SKINCOLOR_WHITE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Everyone had their stats randomized!",
	length = 70,
	runfunc = function(time)
		for p in players.iterate
			p.kartspeed = P_RandomRange(1, 9)
			p.kartweight = P_RandomRange(1, 9)
		end
	end,
}

ck.events[17] = {
	name = "Windy",
	id = "Windy",
	namecol = SKINCOLOR_WHITE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "It got really windy all of a sudden!",
	length = 4*TICRATE,
	varlength = 25*TICRATE,
	playerthink = function(p)
		p.mo.momx = $ - cos(server.windang)/(P_IsObjectOnGround(p.mo) and 4 or 2)
		p.mo.momy = $ - sin(server.windang)/(P_IsObjectOnGround(p.mo) and 4 or 2)
	end,
	runfunc = function(time)
		server.windang = P_RandomRange(0, 359)*ANG1
	end
}

ck.events[18] = {
	name = "Item Loss",
	id = "ItemLoss",
	namecol = SKINCOLOR_WHITE,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "You lost your item!",
	length = 70,
	runfunc = function(time)
		for p in players.iterate do
			p.kartstuff[k_itemtype] = 0
			p.kartstuff[k_itemamount] = 0
		end
	end
}

ck.events[19] = {
	name = "Dud",
	id = "Dud",
	namecol = SKINCOLOR_JET,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Looks like it was just a dud...",
	length = 5*TICRATE,
	runfunc = function(time)
		-- nothing :>
	end
}

ck.events[20] = {
	name = "Jumpdrift",
	id = "Jumpdrift",
	namecol = SKINCOLOR_WHITE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Your wheels feel way more unstable...",
	length = 4*TICRATE,
	varlength = 25*TICRATE,
	playerthink = function(p)
		if p.mo and p.mo.valid
			p.driftjumped = $ or false

			if (p.cmd.buttons & BT_DRIFT) then
				if P_IsObjectOnGround(p.mo) and not p.driftjumped then
					S_StartSound(p.mo, sfx_s3k56)
					P_SetObjectMomZ(p.mo, (p.mo.eflags & MFE_UNDERWATER) and 3*FRACUNIT/2 or 4*FRACUNIT)
					p.driftjumped = true
				end
			end

			if P_IsObjectOnGround(p.mo) and not (p.cmd.buttons & BT_DRIFT)
				p.frameangle = p.mo.angle
				p.driftjumped = false
			end
		end
	end
}

ck.events[21] = {
	name = "Backward Thrust",
	id = "BackwardThrust",
	namecol = SKINCOLOR_JET,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Woah! What was that?",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if p.mo and p.mo.valid then P_InstaThrust(p.mo, p.mo.angle, -P_RandomRange(25, 50)*FRACUNIT) end
		end
	end
}

ck.events[22] = {
	name = "Upward Thrust",
	id = "UpThrust",
	namecol = SKINCOLOR_JET,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Woah! You got launched!",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if p.mo and p.mo.valid then P_SetObjectMomZ(p.mo, P_RandomRange(12, 30)*FRACUNIT) end
		end
	end
}

ck.events[23] = {
	name = "Intense Gravity",
	id = "IntenseGravity",
	namecol = SKINCOLOR_JET,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Crush!",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if p.mo and p.mo.valid then
				P_SetObjectMomZ(p.mo, -100*FRACUNIT)
				p.kartstuff[k_squishedtimer] = $ + TICRATE
			end
		end
	end
}

ck.events[24] = {
	name = "Freeze!",
	id = "FreezeAll",
	namecol = SKINCOLOR_JET,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Everyone was frozen!",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if p.mo and p.mo.valid then
				p.mo.frozen = time or 70
				S_StartSound(p.mo, sfx_freeze)
			end
		end
	end
}

ck.events[25] = {
	name = "Slippery Floor",
	id = "IceFloor",
	namecol = SKINCOLOR_CYAN,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "The floor feels slipperier than usual.",
	length = 4*TICRATE,
	varlength = 30*TICRATE,
	playerthink = function(p)
		p.mo.friction = FRACUNIT
	end,
	onfinish = function()
		for p in players.iterate do
			if p.mo and p.mo.valid then p.mo.friction = 29*FRACUNIT/32 end
		end
	end,
}

ck.events[26] = {
	name = "Ultra Spark",
	id = "UltraSpark",
	namecol = SKINCOLOR_CYAN,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Your spark rate exponentially increased!",
	length = 4*TICRATE,
	varlength = 25*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_driftcharge] > 2 then p.kartstuff[k_driftcharge] = 9000 end
	end,
}

ck.events[27] = {
	name = "No Spark",
	id = "NoSpark",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Your spark rate exponentially decreased!",
	length = 4*TICRATE,
	varlength = 20*TICRATE,
	playerthink = function(p)
		p.kartstuff[k_driftcharge] = 0
	end,
}

ck.events[28] = {
	name = "Item Spam!",
	id = "ItemSpam",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Lootboxes! Come get your lootboxes!",
	length = 4*TICRATE,
	varlength = 15*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_itemamount] <= 1 then p.kartstuff[k_itemroulette] = $+TICRATE end
	end,
}

ck.events[29] = {
	name = "Invisibility",
	id = "Invisible",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Where did you go??",
	length = 4*TICRATE,
	varlength = 35*TICRATE,
	playerthink = function(p)
		if p.mo and p.mo.valid then p.mo.flags2 = $|MF2_DONTDRAW end
	end,
	onfinish = function()
		for p in players.iterate do
			if p.mo and p.mo.valid then p.mo.flags2 = $ & ~MF2_DONTDRAW end
		end
	end
}

ck.events[30] = {
	name = "Lights Out",
	id = "LightsOut",
	namecol = SKINCOLOR_BLACK,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "We had to nerf this one.",
	length = 3*TICRATE,
	varlength = 15*TICRATE,
	canrun = function()
		return not server.eventvars or not server.eventvars[30] or server.eventvars[30] <= 0
	end,
	runfunc = function(time)
		for sector in sectors.iterate do
			sector.lightlevel = $/2
		end
		P_SetupLevelSky(6)
	end,
	onfinish = function()
		P_SetupLevelSky(mapheaderinfo[gamemap].skynum)
		for sector in sectors.iterate do
			sector.lightlevel = $*2
		end
	end
}

ck.events[31] = {
	name = "Bonk Death",
	id = "BonkDeath",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "For your sake... don't bonk.",
	length = 4*TICRATE,
	varlength = 30*TICRATE,
	playerthink = function(p)
		if p.mo and p.mo.valid and not p.spectator then
			if (p.mo.eflags & MFE_JUSTBOUNCEDWALL or p.kartstuff[k_justbumped] >= 1) and p.kartstuff[k_growshrinktimer] <= 1 and p.playerstate == PST_LIVE and not p.exiting and not p.kartstuff[k_invincibilitytimer] then
				K_SpawnMineExplosion(p.mo, p.mo.color)
				S_StartSound(p.mo, sfx_s3k4e)
				P_KillMobj(p.mo)
			end
		end
	end
}

ck.events[32] = {
	name = "Screenshake",
	id = "Screenshake",
	namecol = SKINCOLOR_WHITE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Camerman is slacking.",
	length = 3*TICRATE,
	runfunc = function(time)
		P_StartQuake(200*FRACUNIT, time or 5*TICRATE)
	end
}

ck.events[33] = {
	name = "Kansei Dorifto???",
	id = "KanseiDorifto",
	namecol = SKINCOLOR_BLUE,
	battlemode = false,
	rare = false,
	deathroulette = false,
	desc = "Kansei Dorifto! Your drifting style is different!",
	length = 4*TICRATE,
	varlength = 45*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_driftcharge] > 2 then
			p.kartstuff[k_driftcharge] = 0 
			p.kartstuff[k_driftboost] = TICRATE
		end
	end
}

ck.events[34] = {
	name = "Heavy Gravity",
	id = "HeavyGrav",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Gravity got stronger...?",
	length = 4*TICRATE,
	varlength = 30*TICRATE,
	deathpenalty = 5*TICRATE,
	playerthink = function(p)
		if p.mo and p.mo.valid then
			if not P_IsObjectOnGround(p.mo) then P_SetObjectMomZ(p.mo, -gravity, true) end
		end
	end
}

ck.events[35] = {
	name = "Low Gravity",
	id = "LowGrav",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Gravity got weaker...?",
	length = 4*TICRATE,
	varlength = 30*TICRATE,
	deathpenalty = 5*TICRATE,
	playerthink = function(p)
		if p.mo and p.mo.valid then
			if not P_IsObjectOnGround(p.mo) then P_SetObjectMomZ(p.mo, (gravity/2)/1, true) end
		end
	end
}

ck.events[36] = {
	name = "No Gravity",
	id = "NoGrav",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Gravity... stopped working...?",
	length = 4*TICRATE,
	varlength = 30*TICRATE,
	deathpenalty = 7*TICRATE,
	playerthink = function(p)
		if p.mo and p.mo.valid then
			if not P_IsObjectOnGround(p.mo)
				p.mo.flags = $|MF_NOGRAVITY
			else
				p.mo.flags = $ & ~MF_NOGRAVITY
			end
		end
	end,
	onfinish = function()
		for p in players.iterate do
			if p.mo and p.mo.valid then p.mo.flags = $ & ~MF_NOGRAVITY end
		end
	end
}

ck.events[37] = {
	name = "Bouncy",
	id = "Bouncy",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Boing! Boing!",
	length = 4*TICRATE,
	varlength = 25*TICRATE,
	deathpenalty = 5*TICRATE,
	playerthink = function(p)
		if P_IsObjectOnGround(p.mo)
			P_SetObjectMomZ(p.mo, 20*FRACUNIT)
			P_Thrust(p.mo, p.mo.angle, 20*FRACUNIT)
		end
	end
}

ck.events[38] = {
	name = "Faster",
	id = "Faster",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Faster! Faster!",
	length = 3*TICRATE,
	varlength = 45*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_offroad] == 0 then p.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/3 end
	end
}

ck.events[39] = {
	name = "Faster",
	id = "EvenFaster",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Faster! Faster! Ever so faster!",
	length = 3*TICRATE,
	varlength = 45*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_offroad] == 0 then p.kartstuff[k_boostpower] = 2*FRACUNIT end
	end
}

ck.events[40] = {
	name = "Slower",
	id = "Slower",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Slower. Slower.",
	length = 3*TICRATE,
	varlength = 45*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_offroad] == 0 then p.kartstuff[k_boostpower] = FRACUNIT - FRACUNIT/3  end
	end
}

ck.events[41] = {
	name = "Random Item",
	id = "RandItem",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "You got a random item!",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if not p.mo or not p.mo.valid then continue end
			p.kartstuff[k_itemtype] = P_RandomRange(1, 15)
			p.kartstuff[k_itemamount] = P_RandomRange(1, 3)
		end
	end
}

ck.events[42] = {
	name = "Momentum Loss",
	id = "StopAll",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = true,
	desc = "Stop everything!",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if not p.mo or not p.mo.valid then continue end
			P_InstaThrust(p.mo, p.mo.angle, 0)
			P_SetObjectMomZ(p.mo, 0)
		end
	end
}

ck.events[43] = {
	name = "Random Object",
	id = "RandObj",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "A random object was spawned infront of you.",
	length = 2*TICRATE,
	runfunc = function(time)
		for p in players.iterate do
			if not p.mo or not p.mo.valid then continue end

			local objects = {MT_BLUESPRING, MT_YELLOWSPRING, MT_REDSPRING,
			MT_GRAYSPRING, MT_BLUEDIAG, MT_YELLOWDIAG, MT_REDDIAG, MT_BANANA,
			MT_EGGMANITEM, MT_SSMINE_SHIELD, MT_ORBINAUT, MT_JAWZ_DUD,
			MT_FALLINGROCK, MT_BLUECRAWLA, MT_REDCRAWLA,
			MT_GFZFISH, MT_JETTBOMBER, MT_JETTGUNNER, MT_CRAWLACOMMANDER,
			MT_SKIM, MT_POPUPTURRET, MT_ROBOHOOD, MT_FACESTABBER, MT_EGGGUARD,
			MT_GSNAPPER, MT_ICEBALL, MT_CYBRAKDEMON_FLAMEREST}

			local x, y = 120*cos(p.mo.angle), 120*sin(p.mo.angle)
			P_SpawnMobj(p.mo.x + x, p.mo.y + y, p.mo.z, objects[P_RandomRange(1, #objects)])
		end
	end
}

ck.events[44] = {
	name = "Increased Knockback",
	id = "IncreasedKnockback",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = false,
	deathroulette = false,
	desc = "Spinout distance is increased.",
	length = 3*TICRATE,
	varlength = 50*TICRATE,
	playerthink = function(p)
		if p.kartstuff[k_spinouttimer] then
			if not (leveltime%2) then p.kartstuff[k_spinouttimer] = $-1 end
			p.mo.friction = FRACUNIT
		else
			if p.mo.friction == FRACUNIT then p.mo.friction = 29*FRACUNIT/32 end
		end
	end,
	onfinish = function()
		for p in players.iterate do
			if p.mo and p.mo.valid then p.mo.friction = 29*FRACUNIT/32 end
		end
	end,
}

-----------------
-- RARE EVENTS --
-----------------
ck.events[45] = {
	name = "Brak Eggman!",
	id = "SpawnBrak",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = true,
	deathroulette = false,
	desc = "Brak Eggman appeared!",
	length = 2*TICRATE,
	runfunc = function(time)
		local p = ck.getFirstPlace()
		P_SpawnMobj(p.mo.x+P_RandomRange(-500, 500)<<FRACBITS, p.mo.y+P_RandomRange(-500, 500)<<FRACBITS, p.mo.z + 20*FRACUNIT, MT_CYBRAKDEMON)
	end
}

freeslot("sfx_obanan")
ck.events[46] = {
	name = "Banana Rain",
	id = "BananaRain",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "Ooo... banana...",
	soundplay = sfx_obanan,
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local banana = P_SpawnMobj(tmo.x+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.y+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_BANANA)
			banana.fuse = 30*TICRATE
		end
	end
}

ck.events[47] = {
	name = "Spring Rain",
	id = "SpringRain",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "It's raining springs!",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local possibleHazards = {MT_BLUESPRING, MT_YELLOWSPRING, MT_REDSPRING, MT_GRAYSPRING, MT_BLUEDIAG, MT_YELLOWDIAG, MT_REDDIAG}
			local spring = P_SpawnMobj(tmo.x+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.y+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, possibleHazards[P_RandomRange(1, #possibleHazards)])
			spring.angle = P_RandomRange(0, 360)*ANG1
			spring.fuse = 30*TICRATE
		end
	end
}

ck.events[48] = {
	name = "Ultimate!",
	id = "PrizeLast",
	namecol = SKINCOLOR_YELLOW,
	battlemode = true,
	rare = true,
	deathroulette = false,
	desc = "A prize for last place...",
	length = 2*TICRATE,
	runfunc = function()
		local p = ck.getLastPlace()
		p.mo.destscale = 3*(mapobjectscale/2)
		p.kartstuff[k_growshrinktimer] = 20*TICRATE
		p.kartstuff[k_invincibilitytimer] = 20*TICRATE
	end
}

ck.events[49] = {
	name = "Avalanche",
	id = "Avalanche",
	namecol = SKINCOLOR_BROWN,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "It's raining rocks!",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local rock = P_SpawnMobj(tmo.x+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.y+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_FALLINGROCK)
			rock.scale = P_RandomRange(1, 3)*P_RandomFixed()
			rock.fuse = 20*TICRATE
		end
	end
}

ck.events[50] = {
	name = "Item Rain",
	id = "ItemRain",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "It's raining items!",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local possibleHazards = {MT_BANANA, MT_EGGMANITEM, MT_SSMINE_SHIELD, MT_ORBINAUT, MT_JAWZ_DUD}
			local itemrain = P_SpawnMobj(tmo.x+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.y+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, possibleHazards[P_RandomRange(1, #possibleHazards)])
			itemrain.angle = P_RandomRange(0, 360)*ANG1
			if itemrain.type == MT_JAWZ_DUD then itemrain.target = tmo end
			itemrain.fuse = 30*TICRATE
		end
	end
}

ck.events[51] = {
	name = "Badnik Rain",
	id = "BadnikRain",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "It's raining robots!",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local possibleHazards = {MT_BLUECRAWLA, MT_REDCRAWLA, MT_GFZFISH, MT_JETTBOMBER, MT_JETTGUNNER, MT_CRAWLACOMMANDER, MT_SKIM, MT_POPUPTURRET, MT_ROBOHOOD, MT_FACESTABBER, MT_EGGGUARD, MT_GSNAPPER}
			local badnik = P_SpawnMobj(tmo.x+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.y+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, possibleHazards[P_RandomRange(1, #possibleHazards)])
			badnik.angle = P_RandomRange(0, 360)*ANG1
			badnik.fuse = 40*TICRATE
		end
	end
}

ck.events[52] = {
	name = "Hail",
	id = "Hail",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "It's raining ice!",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local ice = P_SpawnMobj(tmo.x+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.y+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_FIREBALL)
			ice.fuse = 35*TICRATE
			ice.frozen = true
		end
	end
}

ck.events[53] = {
	name = "Firestorm",
	id = "Firestorm",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "It's raining... fire??",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%5) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local fire = P_SpawnMobj(tmo.x+P_RandomRange(-2000, 2000)<<FRACBITS, tmo.y+P_RandomRange(-2000, 2000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 300)<<FRACBITS, MT_CYBRAKDEMON_FLAMEREST)
			fire.fuse = 30*TICRATE
		end
	end
}

ck.events[54] = {
	name = "Global Invisibility",
	id = "GlobalInvisible",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "Where... EVERYTHING go???",
	length = 4*TICRATE,
	varlength = 35*TICRATE,
	thinker = function()
		for mo in thinkers.iterate("mobj")
			if mo and mo.valid then mo.flags2 = $|MF2_DONTDRAW end
		end
	end,
	onfinish = function()
		for mo in thinkers.iterate("mobj")
			if mo and mo.valid then mo.flags2 = $ & ~MF2_DONTDRAW end
		end
	end
}

ck.events[55] = {
	name = "Sink Rain",
	id = "SinkRain",
	namecol = SKINCOLOR_RED,
	battlemode = true,
	rare = true,
	deathroulette = true,
	desc = "WHO LET THE SINKS OUT!!!",
	length = 5*TICRATE,
	varlength = 30*TICRATE,
	thinker = function()
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.spectator then possiblePlayers[#possiblePlayers+1] = p.mo end
		end

		if #possiblePlayers and not (leveltime%2) then
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local sink = P_SpawnMobj(tmo.x+P_RandomRange(-2000, 2000)<<FRACBITS, tmo.y+P_RandomRange(-2000, 2000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 300)<<FRACBITS, MT_SINK)
			sink.fuse = 30*TICRATE
		end
	end
}