local ck = chaosKart

ck.hudFunc = function(v, p, cam)
	if cv_chaoskart.value and server.chaoskarttimer then
		local events = ck.events
		local effects = ck.raceeffects

		if server.curRaceEffect and leveltime < 7*TICRATE then
			local event = effects[server.curRaceEffect]
			v.drawKartString(62, 26, event.name, V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP)
			v.drawString(50, 45, event.desc, V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP, "small")
		end

		local timer = server.chaoskarttimer
		local starttime = (cv_starteventtime.value*TICRATE)

		local x, y = 70, min(6, leveltime-140)

		if (timer < 175) and not server.timerDelay then
			y = $+FixedInt(5*cos(timer*ANG20))
		end

		if not server.deathRoulette then
			local bomtime = timer*55/starttime+(1/2)
			v.drawFill(x+10, y+4, bomtime+15, 5, V_SNAPTOTOP|V_SNAPTOLEFT|1)
			v.drawFill(x+10, y+5, bomtime+15, 3, V_SNAPTOTOP|V_SNAPTOLEFT|99)
			v.draw(x+bomtime+10, y-2, v.cachePatch("FIRE"), V_SNAPTOTOP|V_SNAPTOLEFT)

			if timer <= (starttime/3)
				v.draw(x, y, v.cachePatch("TIMER4"), V_SNAPTOTOP|V_SNAPTOLEFT)
			elseif timer <= (starttime/2)
				v.draw(x, y, v.cachePatch("TIMER3"), V_SNAPTOTOP|V_SNAPTOLEFT)
			elseif timer <= (starttime/2 + starttime/4)
				v.draw(x, y, v.cachePatch("TIMER2"), V_SNAPTOTOP|V_SNAPTOLEFT)
			else
				v.draw(x, y, v.cachePatch("TIMER1"), V_SNAPTOTOP|V_SNAPTOLEFT)
			end

			local color = (timer < 175 and not server.timerDelay) and V_REDMAP or V_BLUEMAP
			v.drawString(x+8, y+7, G_TicsToSeconds(timer), V_SNAPTOTOP|V_SNAPTOLEFT|color, "center")
		end

		if (server.timerDelay or server.deathRoulette) then
			if server.deathRouletteIntro then
				v.drawString(50, 45, "Impending Doom Approaches.", V_SNAPTOLEFT|V_SNAPTOTOP|V_REDMAP|V_ALLOWLOWERCASE, "small")
			else
				if events[server.curEvent] then
					v.drawKartString(x-18, y+20, events[server.curEvent].name, V_SNAPTOLEFT|V_SNAPTOTOP)
				else
					v.drawKartString(x-18, y+20, "Prepare.", V_SNAPTOLEFT|V_SNAPTOTOP)
				end

				if server.deathRoulette then
					v.drawString(50, 45, "Next: "..events[server.nextDeathEvent].name, V_SNAPTOLEFT|V_SNAPTOTOP|V_REDMAP|V_ALLOWLOWERCASE, "small")
				else
					v.drawString(50, 45, events[server.curEvent].desc, V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP|V_ALLOWLOWERCASE, "small")
				end
			end
		end

		-- Display current effects
		local y = 190

		if server.curRaceEffect and effects[server.curRaceEffect] and leveltime > 7*TICRATE then
			local effect = effects[server.curRaceEffect]
			v.drawString(160, y, ">>> "..effect.name.." <<<", V_SNAPTORIGHT|V_SNAPTOTOP|V_BLUEMAP, "center")
			if effect.hudthinker then effect.hudthinker(v, p, cam) end
			y = $-10
		end

		if server.eventvars then
			for k,val in pairs(server.eventvars) do
				if val and val > 0 and ck.events[k] then
					v.drawString(160, y, ck.events[k].name..": "..G_TicsToSeconds(val), V_SNAPTORIGHT|V_SNAPTOTOP|V_ORANGEMAP|V_ALLOWLOWERCASE, "center")
					y = $-10
				end
			end
		end
	end
end