local ck = chaosKart

ck.runEvent = function(eventData, id)
	if eventData.rare then
		S_StartSound(nil, eventData.soundplay or sfx_noooo3)
	else
		S_StartSound(nil, eventData.soundplay or sfx_kc48)
	end

	if eventData.runfunc then eventData.runfunc() end
	server.timerDelay = eventData.length
	server.curEvent = id

	if eventData.varlength then
		if not server.eventvars then server.eventvars = {} end
		server.eventvars[id] = eventData.varlength
	end
end

ck.runRandEvent = function()
	local eventTable = {}

	if P_RandomChance((FRACUNIT/100)*cv_rareeventchance.value) then
		for i = 1, #ck.events do
			if ck.events[i].canrun and not ck.events[i].canrun() then continue end

			if ck.events[i].rare then
				eventTable[#eventTable+1] = {ck.events[i], i}
			end
		end
	else
		for i = 1, #ck.events do
			if ck.events[i].canrun and not ck.events[i].canrun() then continue end

			if not ck.events[i].rare then
				eventTable[#eventTable+1] = {ck.events[i], i}
			end
		end
	end

	local id = P_RandomRange(1, #eventTable)
	local event = eventTable[id][1]
	local realid = eventTable[id][2]

	ck.runEvent(event, realid)
end

ck.doRandRaceEffect = function()
	local possibleEvents = {}
	if P_RandomChance(cv_rareraceeffectchance.value*FRACUNIT/100) then
		for i = 1, #ck.raceeffects do
			if ck.raceeffects[i].rare then possibleEvents[#possibleEvents+1] = {ck.raceeffects[i], i} end
		end
	else
		for i = 1, #ck.raceeffects do
			if not ck.raceeffects[i].rare then possibleEvents[#possibleEvents+1] = {ck.raceeffects[i], i} end
		end
	end

	if not #possibleEvents then return end

	local eid = P_RandomRange(1, #possibleEvents)
	local effect = possibleEvents[eid][1]

	server.curRaceEffect = possibleEvents[eid][2]

	S_StartSound(nil, effect.startsound or sfx_ideya)
	if effect.startfunc then effect.startfunc() end
end

ck.doDeathRoulette = function()
	server.deathRoulette = true
	server.deathRouletteIntro = 8*TICRATE
	S_ChangeMusic("DTHROU", true)
	P_SetupLevelSky(12)
end